searchNodes=[{"doc":"Conveniences for testing GraphQL APIs.You'll probably want to import this module in your ConnCase.","ref":"Absinthe.ConnTest.html","title":"Absinthe.ConnTest","type":"module"},{"doc":"Execute a query against the configured @endpoint and @graphql path.","ref":"Absinthe.ConnTest.html#graphql/3","title":"Absinthe.ConnTest.graphql/3","type":"macro"},{"doc":"","ref":"Absinthe.ConnTest.html#graphql/5","title":"Absinthe.ConnTest.graphql/5","type":"function"},{"doc":"Import queries from a file and convert them to test functions.","ref":"Absinthe.ConnTest.html#import_queries/1","title":"Absinthe.ConnTest.import_queries/1","type":"macro"},{"doc":"","ref":"Absinthe.ConnTest.html#t:error/0","title":"Absinthe.ConnTest.error/0","type":"type"},{"doc":"","ref":"Absinthe.ConnTest.html#t:query/0","title":"Absinthe.ConnTest.query/0","type":"type"},{"doc":"","ref":"Absinthe.ConnTest.html#t:response/0","title":"Absinthe.ConnTest.response/0","type":"type"},{"doc":"","ref":"Absinthe.ConnTest.html#t:variables/0","title":"Absinthe.ConnTest.variables/0","type":"type"},{"doc":"Raised when a query can't be parsed","ref":"Absinthe.ConnTest.LoadError.html","title":"Absinthe.ConnTest.LoadError","type":"exception"},{"doc":"Absinthe.ConnTestThis package makes it really convenient to execute GraphQL queries and mutations against your Phoenix Endpoint.Executing queries as HTTP requests helps to ensure that your application behaves the same way under test as it does under normal circumstances.","ref":"readme.html","title":"Absinthe.ConnTest","type":"extras"},{"doc":"The package can be installed by adding absinthe_conn_test to your list of dependencies in mix.exs:def deps do [ {:absinthe_conn_test, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"Absinthe.ConnTest - Installation","type":"extras"},{"doc":"You'll probably want to import this module in your ConnCase.# test/support/conn_case.ex defmodule MyAppWeb.ConnCase do use ExUnit.CaseTemplate using do quote do # ...etc, etc # Import this library import Absinthe.ConnTest # The default endpoint for testing @endpoint MyAppWeb.Endpoint # The default URL for your GraphQL API @graphql &quot;/graphql&quot; end end # ... etc, etc end","ref":"readme.html#setup","title":"Absinthe.ConnTest - Setup","type":"extras"},{"doc":"A simple test might look something like this:defmodule MyAppWeb.Schema.UsersTest do use MyAppWeb.ConnCase @say_hello &quot;&quot;&quot; query SayHello($name: String!) { hello(name: $name) } &quot;&quot;&quot; test &quot;hello&quot;, %{conn: conn} do assert {:ok, %{&quot;hello&quot; =&gt; &quot;Hello, Ray!&quot;}} = graphql(conn, @say_hello, name: &quot;Ray&quot;) end endImporting queriesYuck, it's kind of annoying to write your queries in your test file. Let's move them to dedicated .graphql file:# test/fixtures/queries.graphql query SayHello($name: String!) { hello(name: $name) }Now, you can import those queries, and they'll become test functions!defmodule MyAppWeb.Schema.UsersTest do use MyAppWeb.ConnCase import_queries &quot;test/fixtures/queries.graphql&quot; test &quot;hello&quot;, %{conn: conn} do assert {:ok, %{&quot;hello&quot; =&gt; &quot;Hello, Ray!&quot;}} = say_hello(conn, name: &quot;Ray&quot;) end endNote that in the example above the SayHello query became a function say_hello.ErrorsErrors are returned in a concise format:test &quot;produces an error message&quot;, %{conn: conn} do assert {:error, [&quot;is invalid&quot;]} = create_user(conn, data: %{}) endIf your error contains extensions, it'll look like this:test &quot;produces an error message with extensions&quot;, %{conn: conn} do assert {:error, [{&quot;is invalid&quot;, %{&quot;code&quot; =&gt; &quot;VALIDATION_ERROR&quot;}}]} = create_user(conn, data: %{}) endFragmentsYup, they're supported too. It will also resolve #import expressions.# test/fixtures/users.graphql fragment User on User { id name }#import &quot;./user.graphql&quot; query ListUsers { users { ...User } }File UploadsIf you attempt to send a %Plug.Upload{} to your API, this library will extract it for you in accordance with Absinthe's file upload specification.# test/fixtures/queries.graphl mutation UploadImage($image: Upload!) { uploadImage(image: $image) }import_queries &quot;test/fixtures/queries.graphql&quot; test &quot;uploading an image&quot;, %{conn: conn} do image = %Plug.Upload{ filename: &quot;foo.png&quot;, path: &quot;test/fixtures/image.png&quot; } assert {:ok, } = upload_image(conn, image: image) end","ref":"readme.html#testing","title":"Absinthe.ConnTest - Testing","type":"extras"}]